#!/bin/bash

config_path="config.txt"

# ==== Parsing configuration file
i=0
while read line; do
if [[ "$line" =~ ^[^#]*= ]]; then
        config_key[i]=`echo $line | cut -d'=' -f 1`
        config_value[i]=`echo $line | cut -d'=' -f 2-`
        ((i++))
fi
done < $config_path

# ==== Functions
function search_array() {
    index=0
    while [ "$index" -lt "${#config_key[@]}" ]; do
        if [ "${config_key[$index]}" = "$1" ]; then
            echo ${config_value[$index]}
            return
        fi
        let "index++"
    done
    echo ""
}

PYTHON=$(search_array "PYTHON")

while [ 1 -le 5 ]
do
  eval "$PYTHON CT_mac_viewer.py"
  if [ $? -eq 0 ]
  then
	exit
  fi
  if [ -r ./tmp/tmp/tmp.tif.lock ]
  then
	rm  ./tmp/tmp/tmp.tif.lock
  fi
  echo `date` " : Restarting playing window"
  echo "Press ESC to quit the program (when the display window is selected"
done
