#!/bin/bash
# ==== Variables
config_path="./bin/config.txt"

# ==== Parsing configuration file
i=0
while read line; do
if [[ "$line" =~ ^[^#]*= ]]; then
        config_key[i]=`echo $line | cut -d'=' -f 1`
        config_value[i]=`echo $line | cut -d'=' -f 2-`
        ((i++))
fi
done < $config_path

# ==== Functions
function search_array() {
    index=0
    while [ "$index" -lt "${#config_key[@]}" ]; do
        if [ "${config_key[$index]}" = "$1" ]; then
            echo ${config_value[$index]}
            return
        fi
        let "index++"
    done
    echo ""
}

# ==== Main program
if [ -r ./tmp/tmp/tmp.tif ]
then
	rm  ./tmp/tmp/tmp.tif
fi
if [ -r ./tmp/tmp/tmp.ended ]
then
	rm  ./tmp/tmp/tmp.ended
fi

cd bin
./CT_mac_viewer.sh &

cd ../
PYTHON=$(search_array "PYTHON")
echo The python interpreter called is: $PYTHON
eval "$PYTHON ./bin/CellTracking.py"
