# Functions that manage the creation of a polygon object and its edition.
# This class inherits from the main Cell class (or the Polygon one

import imp, math
cells = imp.load_source('ct_Cells', './modules/modules_core/ct_Cells.py')

name = 'grid'
Cell = cells.Cell

def get_name() :
	return name

class CellWrapper(Cell) :
	def __init__(self, movie, nb_image, label, use_gtk) :
		self.editable = True
		self.type = 'grid'
		Cell.__init__(self, movie, nb_image, label, use_gtk)
		
		self.reference_size = 15
	def add_from_center(self, frame, center, size, angle, tag=None) :
		self.center = center
		self.size = size
		self.angle = angle
		self.tag = tag
		r = self.calc_rect(center, size, angle)
		self.close = True
		self.color = self.c_color
		#self.add_polygon(r, frame)		#Replaced by 0 to make homogenous behaviour when saving/loading
		self.add_polygon(r, 0)

	def calc_rect(self, c,s,angle) :
		#b1 = math.atan(s[1]/float(s[0])) - angle*math.pi/180
		b1 = math.atan(s[1]/float(s[0])) + angle
		#b2 = math.atan(s[1]/float(s[0])) + angle*math.pi/180
		b2 = math.atan(s[1]/float(s[0])) - angle
		l = (s[0]**2+s[1]**2)**0.5
		r = []
		r.append((int(c[0]-l*math.cos(b1)),int(c[1]-l*math.sin(b1))))
		r.append((int(c[0]+l*math.cos(b2)),int(c[1]-l*math.sin(b2))))
		r.append((int(c[0]+l*math.cos(b1)),int(c[1]+l*math.sin(b1))))
		r.append((int(c[0]-l*math.cos(b2)),int(c[1]+l*math.sin(b2))))		
		
		return r
	def add_point(self, point, frame) :
		pass
		return False
	def draw_polygon(self, image, i, cv, debug=False) :
		self.cv = cv
		image = Cell.draw_polygon(self, image, i, cv, debug)
		if self.tag != None and self.movie.grid.editable:
			cv.Circle(image, self.center, 6, (255,0,0), -1)
			if self.tag == 'origin':
				grid = self.movie.grid.grid_coord.get_object(i)
				(h,v) = self.movie.grid.get_lines(grid[0], grid[1], grid[3])
				lines = h+v
				for (pt1,pt2) in lines :
					cv.Line(image, pt1, pt2, (255,0,0))
		return image
	
	def get_reference_poly(self, i) :
		r = self.reference_size
		c = self.center
		s = self.size
		return self.calc_rect(c, (s[0]+r, s[1]+r), self.angle)

	def move(self,pt, im) :
		"""Functions that moves a point"""
		print "Drag and drop not implemented yet, sorry"
		"""p = self.get_poly(im)		# Get the polygon
		idx = self.get_index(im)	# Gets the index of the image
		
		self.poly_point = []
		#print "IDX:" + str(idx)	# Debug
		if idx == None :	# If the key_poly we are editing doesn't exists
			#print "Creating new frame"	# Debug
			self.create_frame(im)
			idx = self.get_index(im)	# Gets the index of the image
		
		# ==== Determining which point to move
		if self.distance(self.get_center(im), pt) < self.threshold :
			self.poly_point = (self.center_rect, 'rect_center', idx, im)	# [Coordinates, number of the coordinate, frame_key]
			self.big_points = (self.get_center(im), self.color)		# EXP printing
		else :
			for i in range(len(p)) : # Determine what point to move
				d = self.distance(p[i], pt)# Determine the distance
				if d < self.threshold :
					self.poly_point = (p[i], i, idx, im)	# [Coordinates, number of the coordinate, frame_key]
					self.big_points = (self.key_poly[self.poly_point[2]][self.poly_point[1]], self.color)		# EXP printing
					break
		if self.poly_point != [] :
			pass
			#self.big_points = (self.poly_point[0], self.color)
			#if self.poly_point[1] == 'rect_center' :
			#	self.big_points = (self.get_center(im), self.color)
			#self.big_points = (self.key_poly[self.poly_point[2]][self.poly_point[1]], self.color)
		return True	"""
		
	def move2(self, point_m, i) :
		"""Function that really does the movement and updates everything"""
		ret = False
		"""if point_m == (-1, -1) :
			self.poly_point = False
			self.moving = False
		if self.poly_point :	# Do something only if a point has really been clicked
			point_p = self.poly_point		# Get polygon's point location
			if point_p[1] == 'rect_center' :
				center = self.get_center(i)
				dx = point_m[0] - center[0]
				dy = point_m[1] - center[1]
				out_p = []
				for p in self.key_poly[point_p[2]] :	# Move polygon
					out_p.append((p[0]+dx,p[1]+dy))
				self.key_poly[point_p[2]] = out_p
				self.big_points = (center,self.color)
				ret = True
			else :
				old_pt = self.key_poly[point_p[2]][point_p[1]]
				[c_x, c_y] = self.get_center(i)
				dx = abs(point_m[0] - c_x)
				dy = abs(point_m[1] - c_y)
				self.key_poly[point_p[2]] = [(c_x-dx,c_y-dy),(c_x+dx,c_y-dy),(c_x+dx,c_y+dy),(c_x-dx,c_y+dy)]
				self.big_points = (point_m,self.color)
				ret = True
		if ret :
			self.moving = True"""
		return ret	

	def distance(self, p1, p2) :
		d = (p1[0]-p2[0])**2 + (p1[1]-p2[1])**2
		return d	
		
	def get_type(self) :
		return self.type
		
	def get_save_dict(self) :
		dic = Cell.get_save_dict(self)
		dic['editable'] = {'desc' : 'if the cell is editable', 'value' : self.editable}
		dic['reference_size'] = {'desc' : 'The size of the reference around the polygon', 'value' : self.reference_size}
		dic['type'] = {'desc' : 'Type of the cell, which define the CellWrapper to use', 'value' : self.type}
		dic['tag'] = {'desc' : 'Specific tag of the cell (origin, right to origin) to set-up handles', 'value' : self.tag}

		# Should be useless
		dic['center'] = {'desc' : 'Center of the cell', 'value' : self.center}
		dic['size'] = {'desc' : 'Size of the cell', 'value' : self.size}
		dic['angle'] = {'desc' : 'Inclination of the cell', 'value' : self.angle}
		return dic
		
	def set_save_dict(self, dic) :
		Cell.set_save_dict(self, dic)
		self.editable = dic['editable']['value']
		self.type = dic['type']['value']
		self.tag = dic['tag']['value']
		self.reference_size = dic['reference_size']['value']
		self.center = dic['center']['value']
		self.size = dic['size']['value']
		self.angle = dic['angle']['value']
