import time, imp, gobject
mod_open = imp.load_source('mod_open', './modules/modules_load/mod_open.py')

class Movie_GTK :
	"""Class that manages movie controls for an associated movie"""
	def __init__(self, selff, Display, movie, table, frame) :
		"""movie is a Movie instance"""
		self.selff = selff
		self.frame = frame
		self.display_m = Display
		self.visible = True
		self.v_is_locked = False
		self.selected = False
		self.speed_borders = {'min' : -10, 'max' : 10}
		self.table = table
		self.movie = movie
		self.gtk = selff.gtk
		r = 0
		self.add_button_pos = 0
		
		# Select button
		self.cb_select = selff.gtk.CheckButton('Select')
		self.cb_select.connect("clicked", self._clicked_select, {})
		table.attach(self.cb_select, 0, 1, r+1, r+2)
		self.cb_select.show()
		
		# Adding buttons
		play = self._get_play_label(movie)
		self.b_play = self._bouton(selff.gtk, play, self._play_pause, {'movie' : movie})	# Play button
		table.attach(self.b_play, 2, 3, r, r+1)
		
		mode = self._get_mode_label(movie)
		self.b_mode = self._bouton(selff.gtk, mode, self._change_mode, {'movie' : movie})	# Mode button
		table.attach(self.b_mode, 3, 4, r, r+1)	
		
		self.b_switch = self._bouton(selff.gtk, "Switch view", self._switch_view, {'movie' : movie})# Switch button
		table.attach(self.b_switch, 4, 5, r, r+1)
		
		self.b_delete = self._bouton(selff.gtk, "Close", self._close, {'movie' : movie, 'display' : self.display_m, 'selff' : selff})	# Close button
		table.attach(self.b_delete, 5, 6, r, r+1)
		
		# Grid buttons
		#self.b_set_grid = self._bouton(selff.gtk, "Set/Edit Grid", self._set_grid, {'movie' : movie})# Set grid button
		#table.attach(self.b_set_grid, 3, 4, r+1, r+2)
		
		#self.b_process_grid = self._bouton(selff.gtk, "Process grid", self._process_grid, {'movie' : movie})# Process grid button
		#table.attach(self.b_process_grid, 4, 5, r+1, r+2)
		
		#self.b_hide_show_grid = self._bouton(selff.gtk, "Hide/Show grid", movie.grid.show_hide_grid, {})# Process grid button
		#movie.grid.gtk_b_hide_show_grid = self.b_hide_show_grid
		#movie.grid.gtk_b_process_grid = self.b_process_grid
		#if movie.grid.initiated :
		#	self.b_hide_show_grid.set_sensitive(True)
		#	self.b_process_grid.set_sensitive(True)
		#else :
		#	self.b_hide_show_grid.set_sensitive(False)
		#	self.b_process_grid.set_sensitive(False)
		#table.attach(self.b_hide_show_grid, 5, 6, r+1, r+2)	
		
		# Adding speed combobox and label
		name_t = selff.gtk.Label("Speed")
		name_t.show()
		table.attach(name_t, 1,2,r+1, r+2)
		
		speed = self._get_speed(movie)
		speeds = movie.get_speeds()
		self.l_speed  = selff.gtk.combo_box_new_text()
		self.l_speed.connect('changed', self._change_speed, {'movie' : movie})
		
		for s in speeds :
			self.l_speed.append_text(str(s)+"x")
		self.l_speed.set_active(movie.get_speed_index())
		self.l_speed.show()
		table.attach(self.l_speed, 2,3, r+1,r+2)
		
		# Position trackbar
		name_p = selff.gtk.Label("Position")
		name_p.show()
		table.attach(name_p, 1,2,r+2, r+3)
		
		pos_max = movie.get_nb_frames() - 1
		self.s_pos = selff.gtk.HScale(selff.gtk.Adjustment(self._get_pos(movie), 0, pos_max, 1, 1, 0))
		self._update_pos(movie)
		self.s_pos.set_draw_value(True)
		self.s_pos.set_digits(0)
		self.s_pos.set_update_policy(selff.gtk.UPDATE_CONTINUOUS)
		self.s_pos.connect("value-changed", self._change_position, {'movie' : movie})
		self.s_pos.show()
		table.attach(self.s_pos, 2,6, r+2,r+3)
		
		table.show()
		self.table = table
		self.movie.set_display_m_instance(self)		# Register the display_m_instance
		
		# Adding other buttons
		self.movie.import_export.add_gtk_instance(selff.gtk)
		self.movie.import_export.add_save_buttons()
		self.movie.features.add_gtk_instance(selff.gtk)
		self.movie.features.add_features_button()
		self.movie.contrast.add_gtk_instance(selff.gtk)
		self.movie.contrast.add_contrast_button()
		self.movie.polygons_interface.add_gtk_instance(selff.gtk, gobject)
		self.movie.polygons_interface.add_buttons()
		
	def add_button(self, button) :
		pos = self.add_button_pos
		x_pos = pos % 4
		y_pos = pos//4
		#print (x_pos,y_pos)
		self.table.resize(3+y_pos, 6)
		self.table.attach(button, 2+x_pos, 2+x_pos+1, 3+y_pos, 3+y_pos+1)
		self.add_button_pos += 1
	
	def _set_grid(self, widget, data=None) :
		"""Launches the grid module"""
		self.movie.grid.draw_set_grid(self, self.movie)
		self.b_hide_show_grid.set_sensitive(True)
	def _process_grid(self, widget, data=None) :
		self.movie.grid.draw_process_grid(self, self.movie)
		print "processing grid"
	def add_grid(self, grid_object) :
		"""Function that links to the grid module"""
		self.grid = grid_object
	def _close(self, widget, data=None) :
		"""Hides this panel and send close messages"""
		data['movie'].close()
		self.visible = False
		self.movie.close()
		self.table.hide()
		data['display'].redraw(data['selff'])
	def _change_position(self, widget, data=None) :
		"""Sets a new position in the movie"""
		p = int(widget.get_value())
		data['movie'].set_position(p)
	def _change_speed(self, widget, data=None) :
		data['movie'].set_speed_index(widget.get_active())
	def _get_speed(self, movie) :
		"""Function that gets and converts speed from the high scale
		of the keyboard to the short scale on the screen"""
		speed = movie.get_speed()
		if speed > self.speed_borders['max']  :
			speed = self.speed_borders['max']
		elif speed < self.speed_borders['min'] :
			speed = self.speed_borders['min']
		return speed 
	def _get_speed_index(self, movie) :
		return movie.get_speed_index()
	def _update_pos(self, movie) :
		"""Function that synchronizes the trackbar"""
		p = movie.get_frame_index()
		self.s_pos.set_value(float(p))
	def update_player(self) :
		if self.visible :
			self.b_play.set_label(self._get_play_label(self.movie))
			self.b_mode.set_label(self._get_mode_label(self.movie))
			self.l_speed.set_active(self._get_speed_index(self.movie))
			self._update_pos(self.movie)
		
	def _get_pos(self, movie) :
		return movie.get_frame_index()
	def _change_mode(self, widget, data=None) :
		"""Called on click of the mode button"""
		data['movie'].change_mode()
		widget.set_label(self._get_mode_label(data['movie']))
	def _switch_view(self, widget, data=None) :
		data['movie'].change_view()
	def _get_mode_label(self, movie) :
		"""Returns the label for the play button"""
		p = movie.get_mode()
		r = None
		if p == 'automatic' :
			r = "Manual mode"
		else :
			r = "Automatic mode"
		return r
	
	def _get_play_label(self, movie) :
		"""Returns the label for the play button"""
		p = movie.is_playing()
		r = None
		if p :
			r = "Pause"
		else :
			r = "Play"
		return r
	
	def _clicked_select(self, widget, data=None) :
		"""Called when the select button is clicked"""
		if self.selected :
			self.selected = False
		else :
			self.selected = True
		
	def _play_pause(self, widget, data=None) :
		"""Called when the play button is pressed"""
		data['movie'].change_play()
		widget.set_label(self._get_play_label(data['movie']))
	
	def _bouton(self, gtk, label, function, dico) :
		"""Function that adds a button to the parent"""
		bouton = gtk.Button(label)			# Creation d'un nouveau bouton.
		bouton.connect("clicked", function, dico)	# On connecte le signal "clicked" du bouton a la fonction de rappel
		bouton.show()					# This packs the button into the window (a GTK container).
		return bouton  
	def is_selected(self) :
		return self.selected	
	def lock(self) :
		"""Locks the frame"""
		self.v_is_locked = True
		self.selected = False
		self.frame.set_sensitive(False)
		self.frame.set_label(self.frame.get_label()+' - Processing (Please Wait)')
	def unlock(self) :
		"""Unlocks the frame"""
		self.v_is_locked = False
		self.frame.set_sensitive(True)
		self.frame.set_label(self.movie.get_name())
	def is_locked(self) :
		return self.v_is_locked

class Display_m :
	"""Class to display a movie"""
	def __init__(self) :
		self.movies_list = []
		self.table_list = []
		self.frame_list = []
	
	def add_movie(self, selff, movie) :
		"""Creates control playback for the object movie"""
		# Creating and attaching table
		selff.table = selff.gtk.Table(6,4)
		self.table_list.append(selff.table)
		
		# Creating and attaching frame
		frame = selff.gtk.Frame(movie.get_name())
		frame.add(selff.table)
		frame.show()
		self.frame_list.append(frame)
		
		# Instanciate and save movie_GTK
		#############################################
		m = Movie_GTK(selff, self, movie, selff.table, frame)
		self.movies_list.append(m)
		
		# Show all
		self.redraw(selff)
		return m
		
	def get_movies_list(self) :
		"""return a list of GTK instances"""
		return self.movies_list
	
	def redraw(self, selff) :
		"""Function that redraws all the table panel"""
		gtk = selff.gtk
		b_table = selff.main_table
		c = b_table.get_property('n-columns')
		#r = b_table.get_property('n-rows')
		r = selff.main_table_r
		rr = 0
		for i in range(len(self.frame_list)) :
			try :
				b_table.remove(self.frame_list[i])
			except :
				pass
			if self.movies_list[i].visible :
				
				rr += 1
		p=0
		for i in range(len(self.frame_list)) :
			if self.movies_list[i].visible :
				self.table_list[i].show()
				self.frame_list[i].show()
				b_table.attach(self.frame_list[i], 0, 4, r+p, r+p+1)
				p+=1
		b_table.resize(r+rr, c)
		b_table.show()

class Main :
	def __init__(self, gobject, communicate) :
		"""Initializing GTK and the main window"""
		import pygtk
		pygtk.require('2.0')
		import gtk
		import gtk.glade
		
		self.communicate = communicate
		self.gtk = gtk
		self.display_m = Display_m()
		
		# == Creating the main window
		self.window_open_GTK = []				# List of subwindows open
		self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)	# The main window
		self.window.set_title("CellTracking Panel")
		#w = self.window.get_screen().get_width()
		#self.window.move(int(w)- 200,50)
		self.window.set_border_width(10)			# Sets the border width of the window.
		
		# == Creating the main table
		self.main_table_r = 1
		self.main_table = gtk.Table(self.main_table_r, 4, True)			# Creating table to host them
		self.window.add(self.main_table)
		table = gtk.Table(3, 4, True)
		
		# == Creating Menu
		menubar = gtk.MenuBar()

		filemenu = gtk.Menu()
		filem = gtk.MenuItem("File")
		filem.set_submenu(filemenu)
	   
		exit = gtk.MenuItem("Quit")
		exit.connect("activate", self._destroy, {'com' : communicate,'gtk' : gtk})
		filemenu.append(exit)
		menubar.append(filem)
		
		menubar.show()
		table.attach(menubar, 0,4,0,1)

		# == Creating main buttons
		l_please = gtk.Label("Please make sure this window is selected when using a keyboard shortcut \n(and not a playback window)")
		table.attach(l_please, 0, 4, 1, 2)
		
		b_open = self._bouton(gtk, "Open sequence", self._open_seq, {'gtk' : gtk, 'self' : self, 'com' : communicate})# Open seq. button / self param in dict is useless
		table.attach(b_open, 0, 1, 2, 3)
		
		b_keys = self._bouton(gtk, "Keyboard", self._show_message, {"self" : self,\
								"gtk" : gtk,\
								 "parent" : self.window,\
								 "title" :"Key bindings",\
								 "text" : communicate.keys})
		table.attach(b_keys, 1, 2, 2, 3)
				
		b_close_all = self._bouton(gtk, "Close all / NI", self._close_all, {})	# Close all button
		table.attach(b_close_all, 2, 3, 2, 3)
		
		b_quit = self._bouton(gtk, "Quit", self._destroy, {'com' : communicate,'gtk' : gtk})		# Quit button
		table.attach(b_quit, 3, 4, 2, 3)
			
		# == Connecting the main window	
		self.window.connect("delete_event", self._delete_event, {'com' : communicate,'gtk' : gtk})		# On closing
		self.window.connect("destroy", self._destroy, {'com' : communicate,'gtk' : gtk})
		self.window.connect('key_press_event', self._on_key_press_event, {'gtk' : gtk, 'com' : communicate, 'self' : self})# Keyboard manager / The self in the dict is useless
		
		# == Display everything
		self.main_table.attach(table, 0,4,0,1)
		table.show()
		self.main_table.show()
		self.window.show_all()
		
		gobject.timeout_add(150, self._update_players, {'display_m' : self.display_m}) # call every 150ms


	def start(self) :
		self.gtk.main()
	def _update_players(self, data) :
		"""Timer called frequently to update the player"""
		l = data['display_m'].get_movies_list()
		for instan in l :
			instan.update_player()
		return True

	def _on_key_press_event(self, widget, event, data=None):
		"""Mapping the keyboard"""
		gtk = data['gtk']
		keyname = gtk.gdk.keyval_name(event.keyval)
		if keyname == 'Escape' :
			print "ESC key pressed"
			self._destroy(widget, {'gtk' : gtk, '' : data['com']})
		for m in data['self'].display_m.get_movies_list() :
			if m.is_selected() :
				m.movie.set_key_pressed(keyname)

	def _show_message(self, widget, data=None) :
		"""Shows an information message"""
		if data['title'] not in data['self'].window_open_GTK :		# Dont pop if already open
			data['self'].window_open_GTK.append(data['title'])
			gtk=data['gtk']
			window = gtk.Window(gtk.WINDOW_TOPLEVEL)
			window.set_transient_for(data['parent'])
			window.set_title(data['title'])
			window.connect("destroy", self._destroy_w, {'self' : data['self'], 'title' : data['title']})
			label = gtk.Label(data['text'])
			window.add(label)
			window.show_all()
	def _destroy_w(self, widget, data=None) :
		i = data['self'].window_open_GTK.index(data['title'])
		data['self'].window_open_GTK.pop(i)
	def _open_seq(self, widget, data=None) :
		"""Function that opens a folder selection dialog"""
		gtk = data['gtk']
		comm = data['com']
		comm.open_terminated = False
		mod_open.OpenMovie(gtk, self.open_done, self.movies)

	def open_done(self, success, channels=None, movie=None) :
		if success :
			#m = self.movies.add_movie(channels)	# Instanciate movie
			m = self.movies.add_movie(channels, m=movie)	# Instanciate movie
			m.set_channels(channels)
			self.display_m.add_movie(self, m)		# Add movie playback
			self.ddisplay_m.add_movie(m, self.communicate)				# Open movie
			m.import_export.load_all()
			m.polygons_interface.init()
			# Instanciate the movies
		
	def _bouton(self, gtk, label, function, dico) :
		"""Function that adds a button to the parent"""
		bouton = gtk.Button(label)			# Creation d'un nouveau bouton.
		bouton.connect("clicked", function, dico)	 # On connecte le signal "clicked" du bouton a la fonction de rappel
		bouton.show()# This packs the button into the window (a GTK container).
		return bouton    

	def _delete_event(self, widget, event, data=None):
		self._destroy(widget, data)
		return False
		
	def _destroy(self, widget, data=None):
		"""Terminate all"""
		data['com'].terminate = True
		data['gtk'].main_quit()

	def _close_all(self, widget, data=None) :
		print "Function not implemented, sorry"
