#! /usr/bin/env python
# _*-coding:utf-8-*-
# Modifié par PPPP, GPLv3+
# Script managing the tracking from a video source
# based on AntsTracking v0.5.0, janvier 2012 by MW
# CellTracking v0.8a1 by MW

import time, imp, threading

# == Importing all modules
arch = 'debian'		# 'mac' or 'debian'
path = "./modules/modules_OpenCV/"
mod_acquisition = imp.load_source('mod_acquisition', path +'mod_acquisition.py')
#mod_analyse = imp.load_source('mod_analyse', path +'mod_analyse.py')
mod_traitement = imp.load_source('mod_traitement', path +'mod_traitement.py')
mod_multiplexage = imp.load_source('mod_multiplexage', path +'mod_multiplexage.py')
mod_tracking = imp.load_source('mod_tracking', path +'mod_tracking.py')
mod_affichage = imp.load_source('mod_affichage', path +'mod_affichage.py')
mod_fps = imp.load_source('mod_fps', path +'mod_fps.py')

# == Functions
class Movie_OpenCV :
	"""Main functions related to OpenCV"""
	def __init__(self, cv, movie, communicate) :
		self.comm = communicate
		self.movie = movie
		self.movie.lock = threading.Lock()
		movie.set_movie_opencv(self)
		self.cv = cv
		self._init_player()
		self.lock = False		# the lock for the buffer
	def _init_player(self) :
		"""Initializing display"""
		# ==== Initialization
		movie = self.movie
		self.window_name = movie.get_name() + ' -- CellTracking'# Name
		self.dico_images = {}					# Dictionnary containing all images (internal)
		self.buffer_images	= {}				# A copy of the modified frame - This woy od doing does not allow saving for the moment
		self.timer = mod_fps.init()				# FPS counter
		movie.set_size(self.cv.GetSize(self.cv.LoadImage(movie.get_frame_path())))	# Setting video size
		movie.grid.set_cv_grid(self.cv, movie)				# Initializing the CV capabilities of the grid module
		
		###### TO BE DELETED SINCE NO TRACKING IS PERFORMED
		self.tracking_data = mod_tracking.tracking_init()	# Initializing tracking and control dictionnary
		####tracking_data2 = mod_tracking.tracking_init()	# id.
		self.tracking_data['seuil2'] = 17			# id.

		self.tracking_data['seuil1'] = 21			# User interface
		self.tracking_data['seuil2'] = 108
		self.tracking_data['seuil3'] = 255			# id.
		self.tracking_data['erosion'] = 0			# id.
		self.tracking_data['save'] = 0
		self.tracking_data['next'] = 0

		self.pointeurgestiontrack = mod_affichage.init(self.tracking_data, self.window_name, movie)# /!\ Initialize at the end, drawing features (requires previous init)
		self.draw_points = 0
		
		####dico_ref = mod_traitement.reference_init("./Reference/" + nom_fichier + '/')	# Loading reference image
		#dico_images = mod_traitement.double_init(dico_images)	# Loading reference image
		####dico_sortie = []
		
		# ==== Getting first images
		####self.dico_images['brut'] = self.movie.get_frame(i=0, channel='bf_out')
		####self.buffer_images['bf_out'] = self.dico_images['brut']
		
		# ==== Variance association
		if self.movie.channels.get_association_table().has_key('bf_out') and self.movie.channels.get_association_table()['bf_out'] != None and arch=='debian':
			mod_variance = imp.load_source('mod_variance', './modules_treatment/mod_variance.py')
			dico = {'source_channel' : self.movie.channels.get_association_table()['bf_out'][1],
					'movie' : self.movie,
					'name_source' : 'bf_out'}

			loader = mod_variance.Loader(dico)
			ch = self.movie.channels.add_new_channel('Variance', 'variance', loader)
			ch.loader.init()
			
			mod_threshold_GMM = imp.load_source('mod_threshold_GMM', './modules_treatment/mod_threshold_GMM.py')
			dico = {'source_channel' : self.movie.channels.get_association_table()['variance'][1],
					'movie' : self.movie,
					'name_source' : 'variance'}
			loader = mod_threshold_GMM.Loader(dico)
			ch = self.movie.channels.add_new_channel('Gaussian MM', 'gaussian_MM', loader)
			ch.loader.init()
			
			mod_contour = imp.load_source('mod_contour', './modules_treatment/mod_contour.py')
			dico = {'source_channel' : self.movie.channels.get_association_table()['gaussian_MM'][1],
					'movie' : self.movie,
					'name_source' : 'gaussian_MM'}
			loader = mod_contour.Loader(dico)
			ch = self.movie.channels.add_new_channel('Contour', 'contour', loader)
			ch.loader.init()
			self.test = ch


	def get_current_image(self, channel=None) :
		"""Returns a CV image : the one that is currently displayed"""
		## this function is in the wrong place
		r = None
		if channel == None :
			v = self.movie.get_view()
			r = self.buffer_images[v[0]]
		else :
			r = self.buffer_images[channel]
		return r
		
	def set_current_image(self, image) :
		v = self.movie.get_view()
		self.dico_images[v[0]] = image
			
	def play(self, cv) :
		"""Plays once in the loop"""
		# ==== Initializations
		self.cv = cv
		movie = self.movie
		####if self.tracking_data['add_remove_pt'] :
		####	self.tracking_data['add_remove_pt'] = False
		####	print self.tracking_data['pt']	
		self.timer = mod_fps.fps(self.timer)			# Launching FPS counter
		view = movie.get_view()
		
		# ==== Loading images
		####self.dico_images['brut'] = self.movie.get_frame(i=self.movie.get_frame_index(), channel='bf_out', col_channels=3)
		self.dico_images['brut'] = self.movie.get_frame(i=self.movie.get_frame_index(), col_channels=3)
		self.buffer_images['bf_out'] = self.dico_images['brut']
		
		
		asso_list = self.movie.get_association_list()
		###self.buffer_images[view[0]]=self.movie.get_current_frame_CV(view[0]) -> FUTURE
		for key in asso_list :			# This loop is VERY TIME CONSUMING
			self.buffer_images[key] = self.movie.get_frame(i=self.movie.get_frame_index(), channel=key, col_channels=3)
		
		self.dico_images['diff'] = self.dico_images['brut']
		self.dico_images['grey2'] = self.dico_images['brut']
		#self.dico_images['grey2'] = cv.CreateImage(cv.GetSize(self.dico_images['diff']), 8, 3)
		
		"""# =========== Treating images =========
		#(grey, dico_images['diff']) = mod_traitement.normalize(dico_images['diff'], tracking_data['seuil2'], tracking_data['erosion'])	# Normalize

		# Removing small parts (-> Diff)
		dico_images['grey2'] = cv.CreateImage(cv.GetSize(dico_images['diff']), 8, 3)	# Creating black output image
		diff_grey = cv.CreateImage(cv.GetSize(dico_images['diff']), 8, 1)	# Converting diff image to grey
		cv.CvtColor(dico_images['diff'], diff_grey, cv.CV_RGB2GRAY)
		[diff_grey, contours] = mod_traitement.segment_connected(diff_grey, 5)	
		cv.FillPoly(dico_images['grey2'], contours, cv.RGB(255, 255, 255), lineType=8, shift=0)	# Draw the big parts

		# Sticking bigger parts together
		cv.Dilate(dico_images['grey2'],dico_images['grey2'],None,tracking_data['erosion'])
		
		# And removing the remaining ones
		diff_grey = cv.CreateImage(cv.GetSize(dico_images['diff']), 8, 1)	# Converting diff image to grey
		cv.CvtColor(dico_images['grey2'], diff_grey, cv.CV_RGB2GRAY)
		[diff_grey, contours2] = mod_traitement.segment_connected(diff_grey, tracking_data['seuil2'])
		dico_images['grey2'] = cv.CreateImage(cv.GetSize(dico_images['diff']), 8, 3)
		#cv.FillPoly(dico_images['grey2'], contours2, cv.RGB(255, 255, 255), lineType=8, shift=0)	# Draw the big parts


		# Extract and simplify surrounding polygon
		#dico_images['grey2'] = cv.CreateImage(cv.GetSize(dico_images['diff']), 8, 3)	# Creating black output image
		#diff_grey = cv.CreateImage(cv.GetSize(dico_images['diff']), 8, 1)	# Converting diff image to grey
		#cv.CvtColor(dico_images['diff'], diff_grey, cv.CV_RGB2GRAY)
		#[diff_grey, contours] = mod_traitement.segment_connected(diff_grey, 5)	

		for c in contours2 :
			arclength = cv.ArcLength(c)
			polygon = cv.ApproxPoly( c, cv.CreateMemStorage(), cv.CV_POLY_APPROX_DP, arclength * 1/80, 0)
			cv.FillPoly(dico_images['grey2'], [polygon], cv.RGB(100, 100, 100), lineType=8, shift=0)
		"""
		# ==== No Tracking
		#tracking_data2['features'] = []	# To be used if tracking is disabled
		# ==== Saving points if required by user
		#if nom_sortie :
		#	cv.SaveImage(file_sortie+image_names[n], dico_images["grey2"])
		#	# Save file_sortie
		#	#chaine = ''
		#	#for i in tracking_data2['features'] :
		#	#	chaine += str(n) + ' ' +  str(i[0]) + ' ' +  str(i[1]) + '\n'	# Creating the output string
		#	#fichier.write(chaine)	# Saving
		
		# ==== Managing overlays
		if arch == 'debian' :
			self.buffer_images[view[0]] = self.movie.get_overlay(self.buffer_images[view[0]], self.movie.get_frame_index())# Call the movies overlay function
			#self.buffer_images[view[0]] = self.test.loader.overlay(self.buffer_images[view[0]], self.movie.get_frame_index())
				
		# ==== Drawing
		mod_affichage.affichage(self.timer, self.tracking_data, self.tracking_data, self.dico_images, self.pointeurgestiontrack, self.comm, self.movie, self, self.draw_points)	# Send anything required to function
		#			# end, fps	points de track, images,  IHM, dico lecture, numero frame, communication data
		
		movie.set_frame_displayed(movie.get_frame_index())
		movie.next_frame()
	def close(self) :
		"""Destroy display and close everything"""
		self.cv.DestroyWindow(self.window_name)
	
class DDisplay_m :
	"""Class to display movies (OpenCV side)"""
	def __init__(self, cv) :
		self.cv = cv
		self.movies_list = []
		self.to_delete_l = []
	def add_movie(self, movie, communicate) :
		"""Adds a simple movie instance to this display class"""
		m = Movie_OpenCV(self.cv, movie, communicate)		# Instanciate class
		self.movies_list.append(m)	# Save in dict
		
	def get_movies_list(self) :
		return self.movies_list
	def to_delete(self, i) :
		self.to_delete_l.append(i)
	def flush_delete(self) :
		self.to_delete_l.sort(reverse=True)
		for i in self.to_delete_l :
			self.movies_list.pop(i)
		self.to_delete_l = []
		
def init(selff) :
	import cv
	selff.cv = cv
	selff.ddisplay_m = DDisplay_m(cv)
	return selff

def main(selff, cv, communicate) :
	ddisplay_m = selff.ddisplay_m
	while 1 :
		to_delete = []
		for i in range(len(ddisplay_m.get_movies_list())) :
			movie = ddisplay_m.get_movies_list()[i]
			if movie.movie.is_running() :
				movie.play(cv)
			else :
				movie.close()
				ddisplay_m.to_delete(i)
		ddisplay_m.flush_delete()
		
		time.sleep(0.01)


