# Modules that manages all the features
# Features are all the click-based options, like manually adding NEBD tags
# When a feature is enabled, mod_features redirect the user inputs to the
#+ enabled feature.
import imp, gobject

class Features :
	def __init__(self, movie) :
		self.features_list = []
		self.features_dict = {}
		self.features_list_p = [("./modules/modules_features/f_exclude.py", 'f_exclude'),
								("./modules/modules_features/f_phases.py", 'f_phases')]		# A list of feature modules that are being instanciated
		self.movie = movie
		self.visible = False
		#self.current_active_i = None
		self.current_active_w = None
		self.current_active_f = None
		
		for i in self.features_list_p :
			f_m = imp.load_source(i[1], i[0])			# Load
			f = f_m.Feature(movie)
			self.features_list.append((i[0], f))	# Register in list
			self.features_dict[i[0]] = f			# Register in dict
		
	def add_features_button(self) :
		# Adding the button
		l = self._bouton(self.gtk, 'Manage features', self._show_features_panel, {})
		self.movie.display_m.add_button(l)

	def set_click(self, tup) :
		if self.visible :
			cell_l = self.movie.cells.get_cells_list()
			for i in range(len(cell_l)) :
				if cell_l[i].is_point_in_cell(tup) > 0 :			# Get the selected cell
					self.current_active_f.click(cell_l[i], tup)		# Call the right feature
					break
		
	def draw_features_panel(self, gtk) :
		"""Draws the panel"""
		for i in self.movie.cells.get_cells_list() :
			print i.is_selected()
		#self.movie.display_m.b_set_grid.set_sensitive(False)
		
		
		self.widgets_process = gtk.glade.XML('./modules/modules_core/grid.glade',"FeaturesPanel")
		events = { '_close' : self._close,
					'_change_feature' : self._change_feature}
		self.widgets_process.signal_autoconnect(events)	
		self.features_window = self.widgets_process.get_widget('FeaturesPanel')
		self.select_box = self.widgets_process.get_widget('select_box')
		self.main_box = self.widgets_process.get_widget('main_box')
		
		# Create combobox list
		self.l_features  = self.gtk.combo_box_new_text()
		self.l_features.connect('changed', self._change_feature, {})
		
		for f in self.features_list :
			self.l_features.append_text(f[1].get_label())
		self.l_features.set_active(0)
		self.l_features.show()
		self.select_box.pack_start(self.l_features,False, False)
		
		self.timer_features = gobject.timeout_add(200, self._update_features, {}) # call every 200ms
		# Init default panel
		# Bind it 
		# Mrraoow

	def _update_features(self, data) :
		for f in self.features_list :
			f[1].update()
		return True
		
	def _change_feature(self, w, data=None) :
		i = w.get_active()
		if self.current_active_w != None :
			self.main_box.remove(self.current_active_w)	# Delete old widget
		new_w = self.features_list[i][1].get_frame(self.gtk)# Create new widget
		self.main_box.pack_start(new_w)
		self.main_box.reorder_child(new_w, 1)
		self.current_active_w = new_w
		self.current_active_f = self.features_list[i][1]
	def _show_features_panel(self, w, data=None) :
		print "Showing feature panel"
		if self.visible :
			self._close('','')
		else :
			self.draw_features_panel(self.gtk)
			self.visible = True
		
	def add_gtk_instance(self, gtk) :
		self.gtk = gtk
	def _close(self, w, data=None) :
		gobject.source_remove(self.timer_features)
		#self.movie.display_m.b_set_grid.set_sensitive(True)
		self.features_window.destroy()
		self.visible = False
	def _bouton(self, gtk, label, function, dico) :
		"""Function that adds a button to the parent"""
		bouton = gtk.Button(label)			# Creation d'un nouveau bouton.
		bouton.connect("clicked", function, dico)	 # On connecte le signal "clicked" du bouton a la fonction de rappel
		bouton.show()# This packs the button into the window (a GTK container).
		return bouton
