class Feature :
	def __init__(self, movie) :
		self.name = "Cells excluded"
		self.label = "Exclude Cells"
		self.panel_visible = False
		
		self.movie = movie
	def get_label(self) :
		return self.label
	def update(self) :
		if self.panel_visible :
			s = self.get_select_list()
			for i in range(len(s)) :
				self.liststore[i][1] = not s[i]
	def click(self, cell, pt) :
		cell.change_select()
	def get_select_list(self) :
		l = []
		cells_l = self.movie.cells.get_cells_list()
		for c in cells_l :
			l.append(c.is_selected())
		return l
	def get_frame(self, gtk) :
		self.panel_visible = True
		#print "Happily setting frame for " + self.name
		frame = gtk.Frame(self.name)
		box = gtk.VBox()
		frame.show()
		box.show()
		frame.add(box)
		
		l = gtk.Label("Click cells to exclude them.")
		l.show()
		box.pack_start(l)
		
		cells_l = self.movie.cells.get_cells_list()
		
		# Creating view
		self.liststore = gtk.ListStore(str, bool, int)
		#false = [False]*len(cells_l)		#### TO CORRECT TO HAVE THE SELECTION UPDATED
		sel = self.get_select_list()
		for i in range(len(cells_l)) :
			self.liststore.append([str(cells_l[i].get_label()), not sel[i], i])	# Add autoselect after

		self.excl_tv = gtk.TreeView(self.liststore)
		self.excl_tv.show()
		column_text = gtk.TreeViewColumn("Cell index")
		column_toggle = gtk.TreeViewColumn("Excluded?")
		
		self.excl_tv.append_column(column_text)
		self.excl_tv.append_column(column_toggle)
		cellrenderer_text = gtk.CellRendererText()
		column_text.pack_start(cellrenderer_text, False)
		column_text.add_attribute(cellrenderer_text, "text", 0)
		
		cellrenderer_toggle = gtk.CellRendererToggle()
		column_toggle.pack_start(cellrenderer_toggle, True)
		column_toggle.add_attribute(cellrenderer_toggle, "active", 1)
		
		cellrenderer_toggle.connect("toggled", self._cell_toggled, self.liststore)
		
		#cb.set_active(0)		# To change
		box.pack_start(self.excl_tv)
		
		# Creating select buttons
		bottom_box = gtk.HBox()
		bottom_box.show()
		box.pack_start(bottom_box)
		self.b_select_all = self._bouton(gtk, 'Exclude all', self._exclude_all, {})
		self.b_select_none = self._bouton(gtk, 'Exclude none', self._exclude_none, {})
		bottom_box.pack_start(self.b_select_all)
		bottom_box.pack_start(self.b_select_none)
		
		return frame
	def _exclude_all(self, w, data=None) :
		cell_l = self.movie.cells.get_cells_list()
		for i in range(len(cell_l)) :
			cell_l[i].unselect(True)
			#self.liststore[i][1] = True
	def _exclude_none(self, w, data=None) :
		cell_l = self.movie.cells.get_cells_list()
		for i in range(len(cell_l)) :
			cell_l[i].select(True)
			#self.liststore[i][1] = False
	def _cell_toggled(self, widget, path, model):
		model[path][1] = not model[path][1]
		i = model[path][2]			# The index of the selected cell
		state = model[path][1]		# Its state (activated or not)
		#channel_i = model[path][4]	# index of the channel
		#ch = self.channels.get_channel(channel_i)
		#ch.change_select(i, state)"""
		inst = self.movie.cells.get_cells_list()[i]		# Get cell
		inst.change_select(state=not state)							# Change its selection
	def _bouton(self, gtk, label, function, dico) :
		"""Function that adds a button to the parent"""
		bouton = gtk.Button(label)			# Creation d'un nouveau bouton.
		bouton.connect("clicked", function, dico)	 # On connecte le signal "clicked" du bouton a la fonction de rappel
		bouton.show()# This packs the button into the window (a GTK container).
		return bouton
		
