#!/usr/bin/python
# -*- coding: iso-8859-1 -*-
import imp
import pygtk
pygtk.require("2.0")
import gtk
import gtk.glade

import os
#print os.getcwd()
mod_channels = imp.load_source('mod_channels', './modules/modules_core/mod_channels.py')
mod_load_folder = imp.load_source('mod_load_folder', './modules/modules_load/mod_load_folder.py')
mod_load_file = imp.load_source('mod_load_file', './modules/modules_load/mod_load_file.py')


class OpenMovie :
	def __init__(self, gtk, done_function, movies):
		self.movies = movies
		self.tmp_movie = self.movies.new_movie()
		self.done = done_function
		self.gtk = gtk
		self.channels_list = []
		self.channels = mod_channels.Channels()
		self.channels_l = ['Unused', 'Bright Field (in focus)', 'Bright Field (out of focus)', 'YFP', 'Cherry', 'Cerulean', 'Other']
		self.channels_i = ['unused', 'bf_in', 'bf_out', 'yfp', 'cherry', 'cer', 'other']
		self.caption = ["Don't use this channel",\
						"unused for the moment - Non implemented",\
						"Used for segmentation",\
						"YFP channel",\
						"cherry channel",\
						"Cerulaen channel",\
						"A channel to be displayed,\n but that is not involved in processing"]
				
		self.mod_loaders = {'folder' : mod_load_folder, 'file' : mod_load_file}		
		self.load_folder = mod_load_folder.LoadFolder(self, self.tmp_movie)
		self.load_file = mod_load_file.LoadFile(self, self.mod_loaders, self.tmp_movie)
		
		self.import_mode = 'folder'
		self.widgets_open = gtk.glade.XML('./modules/modules_core/grid.glade',"OpenDialog")
		events = {'_close_w': self._close_w,
			'_cancel' : self._cancel,
			'_wit_folder' : self._wit_folder,
			'_wit_file' : self._wit_file,
			'_sb_change_select' : self._sb_change_select,
			'_load': self._load,
			}
		
		self.widgets_open.signal_autoconnect(events)
		self.open_window = self.widgets_open.get_widget('OpenDialog')
		al = self.widgets_open.get_widget('asso_w')
		self.asso_box = gtk.VBox()
		self.asso_box.show()
		al.add_with_viewport(self.asso_box)
		
		# Load folder box
		self.box_folder = self.widgets_open.get_widget('box_load_folder')
		self.load_folder_box = self.load_folder.show_open_table_GTK(gtk)
		self.box_folder.add(self.load_folder_box)
		self.box_folder.reorder_child(self.load_folder_box, 1)
		
		self.box_file = self.widgets_open.get_widget('box_load_file')
		self.load_file_box = self.load_file.show_open_table_GTK(gtk)
		self.box_file.add(self.load_file_box)
		self.box_file.reorder_child(self.load_file_box, 1)
		self.load_file_box.set_sensitive(False)
		
		self.select_file = self.widgets_open.get_widget('sb_fi')
		self.select_folder = self.widgets_open.get_widget('sb_fo')
	def _close_w(self, source=None, event=None):
		source.destroy()
	
	def _cancel(self, source=None, event=None):
		self.done(False)
		self.open_window.destroy()
	def _sb_change_select(self, source=None, event=None):
		if self.select_folder.get_active() :
			self.import_mode ='folder'
			self.load_folder_box.set_sensitive(True)
			self.load_file_box.set_sensitive(False)
		else :
			self.import_mode = 'file'
			self.load_folder_box.set_sensitive(False)
			self.load_file_box.set_sensitive(True)

	def _load(self, source=None, event=None) :
		gtk = self.gtk
		(ok0, ok, ok2, ok3) = self.channels.check_channels()
		if not ok0 or not ok3:
			md = gtk.MessageDialog(None, 
				gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_INFO, 
				gtk.BUTTONS_CLOSE, "Nothing to load...")
			md.run()
			md.destroy()
		else :
			if not ok :
				md = gtk.MessageDialog(None, 
					gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_ERROR, 
					gtk.BUTTONS_CLOSE, "You can associate many times your data wit the proposed input\n\
	channels, but you cannot associated twice an input channel with the same data movie. Please correct.")
				md.run()
				md.destroy()
			elif not ok2 :
				md = gtk.MessageDialog(None, 
					gtk.DIALOG_DESTROY_WITH_PARENT, gtk.MESSAGE_ERROR, 
					gtk.BUTTONS_CLOSE, "You cannot select any input channel if you check the Unused button")
				md.run()
				md.destroy()			
			else :
				print "Everything seems ok, checking"
				self.channels.configure_channels()
				self.channels.update_loaders()
				print "Everything seems ok, loading"
				self.done(True, self.channels, self.tmp_movie)
				self.open_window.destroy()
				
	def _wit_folder(self, source=None, event=None):
		gtk = self.gtk
		gtk.glade = self.gtk.glade
		self.w_wit_folder = gtk.glade.XML('./modules_load/grid.glade',"wit_folder")
		self.w_wit_folder.signal_autoconnect({'_close_wit_fo' : self._close_wit_fo})
		self.ww_wit_folder= self.w_wit_folder.get_widget('wit_folder')
	def _close_wit_fo(self, source=None, event=None) :
		self.ww_wit_folder.destroy()
	def _wit_file(self, source=None, event=None):
		gtk = self.gtk
		gtk.glade = self.gtk.glade
		self.w_wit_file = gtk.glade.XML('./modules_load/grid.glade',"wit_file")
		self.w_wit_file.signal_autoconnect({'_close_wit_fi' : self._close_wit_fi})
		self.ww_wit_file= self.w_wit_file.get_widget('wit_file')
	def _close_wit_fi(self, source=None, event=None) :
		self.ww_wit_file.destroy()
	def _cb_selection(self, w, ch, liststore) :
		i = w.get_active()
		if i==0 :
			ch.exp_tv.set_sensitive(False)
		else : 
			ch.exp_tv.set_sensitive(True)
		ch.upd_button(i)
		l = ch.get_asso_list()
		for j in range(len(l)) :
			liststore[j][1] = l[j]
		# Call panel update
	def clear_channels(self) :
		self.channels.clear_channels()
		for i in self.channels_list :
			i.destroy()
		self.channels_list = []
	def clear_keep_n_channels(self,n) :
		"""Erase all channels except the n first ones"""
		k = len(self.channels_list)
		for j in range(n,k) :
			self.channels_list[j].destroy()
		self.channels_list = self.channels_list[:n]
		
		self.asso_box
	def set_name(self, name) :
		"""Sets the name of the global sequence opened"""
		self.channels.set_name(name)
	def add_channel(self, dico, loader_init=True)  :
		"""Function that adds a channel to the channel control panel"""
		gtk = self.gtk
		if loader_init :
			ch = self.channels.add_channel(dico['name'], self.channels_l, self.channels_i,mod_load_folder.Loader(dico['data']))	# Instanciating channel
			index = ch.get_index()
			parent = self.asso_box
			expander = gtk.Expander('More association options')
			expander.show()
			
			# Creating frame
			cb  = gtk.combo_box_new_text()
			for s in self.channels_l :
				cb.append_text(s)
			cb.show()
			
			name_box = gtk.HBox()
			l_name = gtk.Label()
			l_name.show()
			l_name.set_markup('<b>'+dico['name'] + '</b> - ')
			l_int = gtk.Label(dico['text_label'])
			l_int.show()
			l_quick_asso = gtk.Label(' - Quick association : ')
			l_quick_asso.show()
			
			name_box.pack_start(l_name)
			name_box.pack_start(l_int)
			name_box.pack_start(l_quick_asso)
			name_box.pack_start(cb)
			name_box.show()
			
			frame = gtk.Frame()
			self.channels_list.append(frame)
			frame.set_label_widget(name_box)
			frame.add(expander)
			frame.show()
			
			parent.pack_start(frame)
			parent.show()
			expander.connect('notify::expanded', self._expanded_cb, ch)
			
			# Creating expander
			liststore = gtk.ListStore(str, bool, str, int, int)
			false = [False]*len(self.channels_l)		#### TO CORRECT TO HAVE THE SELECTION UPDATED
			false[0] = True
			for i in range(len(self.channels_l)) :
				liststore.append([self.channels_l[i], false[i], self.caption[i], i, index])	# Add autoselect after
				
			# Explanation frame 
			exp_frame = gtk.Frame('Click on an input channel to see its description')
			ch.l_explanation = gtk.Label()
			ch.l_explanation.show()
			exp_frame.add(ch.l_explanation)
			exp_frame.show()
			
			# Filling expander
			ch.exp_box =  gtk.HBox()	# The main box
			ch.exp_box.show()
			ch.exp_tv = gtk.TreeView(liststore)
			ch.exp_tv.show()
			#column_nb = gtk.TreeViewColumn('nb')
			column_text = gtk.TreeViewColumn("Input channel")
			column_toggle = gtk.TreeViewColumn("Associated")
			
			ch.exp_tv.append_column(column_text)
			ch.exp_tv.append_column(column_toggle)
			#exp_tv.append_column(column_nb)
			ch.exp_tv.connect('button-press-event', self._tv_select, ch.l_explanation)

			cellrenderer_text = gtk.CellRendererText()
			column_text.pack_start(cellrenderer_text, False)
			column_text.add_attribute(cellrenderer_text, "text", 0)
			
			cellrenderer_toggle = gtk.CellRendererToggle()
			column_toggle.pack_start(cellrenderer_toggle, True)
			column_toggle.add_attribute(cellrenderer_toggle, "active", 1)
			
			cellrenderer_toggle.connect("toggled", self.cell_toggled, liststore)
			
			cb.set_active(0)		# To change
			ch.exp_tv.set_sensitive(False)
			cb.connect('changed', self._cb_selection, ch, liststore)
			
			ch.exp_box.pack_start(ch.exp_tv)
			ch.exp_box.pack_start(exp_frame)
		else :	# We already have a loader
			frame = gtk.Frame(dico['name'] + ' ' + dico['text_label'])
			frame.show()
			parent = self.asso_box
			parent.pack_start(frame)
			parent.show()
			#ch = self.channels.add_channel(dico['name'], dico['name_index'], dico['loader'], dico['asso_list'])	# Instanciating channel
			ch = self.channels.add_channel(dico['name'], self.channels_l, self.channels_i,dico['loader'], dico['asso_list'])	# Instanciating channel

		
	def _tv_select(self, treeview, event,l_explanation):
		'''Action pour le bouton droit'''
		if event.button == 1:
		  x = int(event.x)
		  y = int(event.y)
		  pthinfo = treeview.get_path_at_pos(x, y)
		  if pthinfo != None:
			path, col, cellx, celly = pthinfo
			treeview.grab_focus()
			treeview.set_cursor( path, col, 0)
		  model = treeview.get_model()
		  iter = model.get_iter(path)
		  #content = model[iter][0]
		  caption = model[iter][2]
		  l_explanation.set_label(caption)
		  
	def cell_toggled(self, widget, path, model):
		model[path][1] = not model[path][1]
		i = model[path][3]			# The selected input
		state = model[path][1]		# Its state (activated or not)
		channel_i = model[path][4]	# index of the channel
		ch = self.channels.get_channel(channel_i)
		ch.change_select(i, state)
		
		
	def _expanded_cb(self, expander, tt, ch):
		if expander.get_expanded():
			#label = gtk.Label('youpi')
			#label.show()
			expander.add(ch.exp_box)
		else:
			expander.remove(expander.child)
		return

if __name__ == '__main__':
	app = OpenMovie(gtk, gtk.glade)
	gtk.main()
