# Thresholding based on Gaussian Mixture Models
# See http://en.wikipedia.org/wiki/Mixture_model#Gaussian_mixture_model for the theory
#+ and http://scipy-lectures.github.com/advanced/image_processing/index.html for the
#+ implementation

import cv, os
import numpy as np
from scipy import misc
from scipy import ndimage
class Loader :
	def __init__(self, data) :
		"""A first init, but all the parameters ore not properly initiated"""
		self.loader_type = 'threshold_GMM'
		self.source_channel = data['source_channel']	# The channel to be modified
		self.movie = data['movie']						# The source movie
		self.name_source = data['name_source']
		self.nb_files = self.movie.get_nb_frames()
		self.output_folder = './tmp/threshold_GMM/'
	def update(self) :
		pass
	def get_loader_type(self) :
		"""The first value is 'is_inherited'"""
		return (True, self.loader_type)
	def init(self) :
		"""The final initialization"""
		# Creating/init the output directory
		path = self.output_folder + self.movie.get_name() + '-' + self.name_source + '/'
		create = False
		print "-- Checking folders"
		if not os.path.isdir(path) :
			os.mkdir(path)
			create = True
		elif len(os.listdir(path)) != self.nb_files :
			create = True
		print "-- Exporting GMM"
		if create :
			for i in range(self.nb_files) :
				p = path + 'GaussianMixture' + str(i) + '.png'
				im_p = self.source_channel.loader.get_frame_path(i)
				im = misc.imread(im_p)
				
				# Applying Gaussian Mixture Model Threshold
				l = im.shape[0]/4
				n = 10
				im = ndimage.gaussian_filter(im, sigma=l/(4.*n))
				mask = (im > im.mean()).astype(np.float)
				mask += 0.1 * im
				img = mask #+ 0.2*np.random.randn(*mask.shape)

				hist, bin_edges = np.histogram(img, bins=60)
				bin_centers = 0.5*(bin_edges[:-1] + bin_edges[1:])
				
				#img = img/np.max(img)
				binary_img = img > 14*0.5		# An important threshold

				misc.imsave(p, binary_img)

				if i%5 == 0 :
					print 'GaussianMixture' + str(i) + '.png'
		else :
			print 'Opening already saved images at path ' + path
		self.folder = path
		print "-- Done!"
		
		
	def get_nb_frames(self) :
		return self.nb_files
	def get_frame_path(self, i) :
		print 'threshold GMM module has no get_frame_path option'
	def get_frame_CV(self, i) :
		# importing image
		out = cv.LoadImage(self.folder + 'GaussianMixture' + str(i) + '.png')
		"""im_cv = self.source_channel.loader.get_frame_CV(i)
		gray_cv = cv.CreateImage(cv.GetSize(im_cv), im_cv.depth, 1)
		cv.CvtColor(im_cv, gray_cv, cv.CV_RGB2GRAY)
		
		ma_cv = cv.GetMat(gray_cv)
		im = numpy.asarray(ma_cv)
		
		# Applying Gaussian Mixture Model Threshold
		l = im.shape[0]/32
		n = 10
		im = ndimage.gaussian_filter(im, sigma=l/(4.*n))
		mask = (im > im.mean()).astype(numpy.float)
		mask += 0.1 * im
		img = mask #+ 0.2*np.random.randn(*mask.shape)

		hist, bin_edges = numpy.histogram(img, bins=60)
		bin_centers = 0.5*(bin_edges[:-1] + bin_edges[1:])

		binary_img = img > 0.7		# An important threshold

		scipy.misc.imsave('test.png', binary_img)
		out = cv.LoadImage('test.png')"""
		return out	# Return image
